package main

import (
	"fmt"
	zmostp_go "git.swzry.com/zry/zmostp/zmostp-go"
)

type LogHandler struct {
}

func (l LogHandler) DFAInvalidState(st zmostp_go.DFAState) {
	fmt.Printf("[WRN] invalid DFA state: %d\n", st)
}

func (l LogHandler) DFAInvalidInput(st zmostp_go.DFAState, b byte) {
	fmt.Printf("[WRN] invalid input '%d' on DFA state '%s'\n", b, st.ToAbbr())
}

func (l LogHandler) DecodeChannelAscii85Failed(data []byte, err error) {
	fmt.Printf("[WRN] failed decoding channel data '%s' with ascii-85 encoding: %v\n", string(data), err)
}

func (l LogHandler) DecodePayloadAscii85Failed(ch uint32, data []byte, err error) {
	fmt.Printf("[WRN] failed decoding payload data '%s' on ch %d with ascii-85 encoding: %v\n", string(data), ch, err)
}

func (l LogHandler) DecodeChecksumAscii85Failed(ch uint32, data []byte, err error) {
	fmt.Printf("[WRN] failed decoding checksum data '%s' on ch %d with ascii-85 encoding: %v\n", string(data), ch, err)
}

func (l LogHandler) NeedCRCChecksum() {
	fmt.Println("[WRN] need CRC checksum")
}

func (l LogHandler) CRCChecksumMismached(crcFromData uint32, crcReceived uint32) {
	fmt.Printf("[WRN] CRC checksum mismatch: want %d, got %d\n", crcFromData, crcReceived)
}

func (l LogHandler) InvalidChannelByteLength(data []byte) {
	fmt.Printf("[WRN] invalid channel byte length, data: %v\n", data)
}

func (l LogHandler) InvalidChecksumByteLength(ch uint32, data []byte) {
	fmt.Printf("[WRN] invalid checksum byte length,ch %d, data: %v\n", ch, data)
}

var _ zmostp_go.DecodeFailureLogHandler = (*LogHandler)(nil)
