package test3

import (
	"fmt"
	zmostp_go "git.swzry.com/zry/zmostp/zmostp-go"
)

type LogHandler struct {
}

func (l LogHandler) DecodeChecksumAscii85Failed(ch uint32, data []byte, err error) {
	perr := fmt.Errorf("failed decoding checksum '%s' with ascii85 (ch=%d): %v", string(data), ch, err)
	panic(perr)
}

func (l LogHandler) NeedCRCChecksum() {
	perr := fmt.Errorf("crc checksum enabled but received data has no crc checksum")
	panic(perr)
}

func (l LogHandler) CRCChecksumMismached(crcFromData uint32, crcReceived uint32) {
	perr := fmt.Errorf("crc mismatch: calculated from data: %d, received: %d", crcFromData, crcReceived)
	panic(perr)
}

func (l LogHandler) DFAInvalidState(st zmostp_go.DFAState) {
	perr := fmt.Errorf("invalid dfa state: %d", st)
	panic(perr)
}

func (l LogHandler) DFAInvalidInput(st zmostp_go.DFAState, b byte) {
	perr := fmt.Errorf("invalid input: %d in state '%s' ", b, st.ToAbbr())
	panic(perr)
}

func (l LogHandler) DecodeChannelAscii85Failed(data []byte, err error) {
	perr := fmt.Errorf("failed decoding channel '%s' with ascii85: %v", string(data), err)
	panic(perr)
}

func (l LogHandler) DecodePayloadAscii85Failed(ch uint32, data []byte, err error) {
	perr := fmt.Errorf("failed decoding payload '%s' with ascii85 (ch=%d): %v", string(data), ch, err)
	panic(perr)
}

func (l LogHandler) InvalidChannelByteLength(data []byte) {
	perr := fmt.Errorf("invalid channel byte length, data: %v", data)
	panic(perr)
}

func (l LogHandler) InvalidChecksumByteLength(ch uint32, data []byte) {
	perr := fmt.Errorf("invalid checksum byte length, ch: %d, data: %v", ch, data)
	panic(perr)
}

var _ zmostp_go.DecodeFailureLogHandler = (*LogHandler)(nil)
